package com.javaranch.common ;

import java.util.* ;
import java.io.*;
import java.net.*;
import LocalSystem ;

/** Emails a message to a user. <p>
    - - - - - - - - - - - - - - - - - <p>
    
    Copyright (c) 1999-2000 Paul Wheaton <p>
    Copyright (c) 1999-2000 EarthWatch, Inc.
    
    You are welcome to do whatever you want to with this source file provided
    that you maintain this comment fragment (between the dashed lines).
    Modify it, change the package name, change the class name ... personal or business 
    use ...  sell it, share it ... add a copyright for the portions you add ... <p>
    
    My goal in giving this away and maintaining the copyright is to hopefully direct 
    developers back to JavaRanch. <p>
    
    I originally developed this class while working as a contractor at EarthWatch, Inc. in
    Longmont, Colorado.  They gave me permission to distribute this code this way provided
    that their message would also be carried along.  Their message is that they hire
    Java programmers and would like you to consider working with them.  I have to say
    that my experience with them was first rate and I would encourage engineers to work there.
    Check out their web site at <a href=http://www.digitalglobe.com>http://www.digitalglobe.com</a>. <p>
    
    The original source can be found at <a href=http://www.javaranch.com>JavaRanch</a> <p>
    
    - - - - - - - - - - - - - - - - - <p>

    @author Nathan Paris
    @author Paul Wheaton
*/
public class Email
{

    private static final int standardSMTPPort = 25 ;

    /** Send an e-mail. <p>

        @param to A valid destination e-mail address. <p>
        @param from Report who or what this e-mail is from - maybe "GDSStartServlet@digitalglobe.com". <p>
        @param message The meat of the message. <p>
        @param smtpServer A valid domain name for a computer with an SMTP server. <p>
    */
    public static void send( String to , String from , String message , String smtpServer ) throws IOException
    {
        Socket socket = new Socket( smtpServer , standardSMTPPort );
        PrintStream out = new PrintStream( socket.getOutputStream() );

        out.println( "MAIL FROM:" + from );
        out.println( "RCPT TO:" + to );
        out.println( "DATA\n" );
        out.println( message );
        out.println( "\n." );
        out.flush();
        socket.close();
    }

    /** Send an e-mail to the admin via the server specified in LocalSystem. <p>

        @param from Report who or what this e-mail is from - maybe "GDS StartServlet". <p>
        @param message The meat of the message. <p>
    */
    public static void send( String from , String message ) throws IOException
    {
        send( LocalSystem.getAdminEmail() , from , message , LocalSystem.getSMTPServer() );
    }

    /** For unit testing purposes only. <p>
    */
    public static void main( String[] args ) throws IOException
    {
        send( "UnitTest@digitalglobe.com" , "testing...\n\nSpoooooon!" );
    }

}
