
package com.javaranch.common ;

import java.applet.* ;
import java.awt.* ;
import java.net.* ;
import java.io.* ;

/** This class helps you load images before you use them. <p>

    Java allows you to show parts of an image before the whole image is loaded.
    This class forces the entire image to be loaded before you attempt to use it. <p>

    
    - - - - - - - - - - - - - - - - - <p>
    
    Copyright (c) 1998-2000 Paul Wheaton <p>
    
    You are welcome to do whatever you want to with this source file provided
    that you maintain this comment fragment (between the dashed lines).
    Modify it, change the package name, change the class name ... personal or business 
    use ...  sell it, share it ... add a copyright for the portions you add ... <p>
    
    My goal in giving this away and maintaining the copyright is to hopefully direct 
    developers back to JavaRanch. <p>
    
    The original source can be found at <a href=http://www.javaranch.com>JavaRanch</a> <p>
    
    - - - - - - - - - - - - - - - - - <p>

    @author Paul Wheaton
*/

public class ImageLoader
{
    private static int waitDelay = 0 ;

    // my first whacks at this class were kind of kludgy and now I've managed to evolve past the
    // kludges.  However, I might want some of this code again later, so I keep it around.



    /*
    private static Applet applet = null ;
    private static String baseURL ;
    private static boolean loadImagesFromJar ;
    */

    /*
    public static void init( Applet applet , String baseURL , boolean loadImagesFromJar )
    {
        ImageLoader.applet = applet ;
        ImageLoader.baseURL = baseURL ;
        ImageLoader.loadImagesFromJar = loadImagesFromJar ;
    }

    public static boolean isInitialized()
    {
        return ( applet != null );
    }
    */

    /** Corrects a problem in some VM's. <p>

        For some unix VM's, not having this delay will make the wait for loading last forever.  Giving
        some value here will make the wait work properly. <p>
    */
    public static void setWaitDelay( int millisecs )
    {
        waitDelay = millisecs ;
    }

    private static void waitForImage( Image i )
    {
        while( i.getHeight( null ) < 0 )
        {
            // If there is no delay here, unix boxes will get stuck.  Strange but true.
            if ( waitDelay > 0 )
            {
                //System.out.println("xxx loading image");
                Time.delay( waitDelay );
            }
            Thread.yield();
        }
    }

    /* Attempt to get the image and throw an exception if one is encountered. <p>
    */
    /*
    public static Image getE( String s ) throws Exception
    {
        Image i = null ;
        if ( loadImagesFromJar )
        {
            InputStream in = applet.getClass().getResourceAsStream( s );
            if (in == null)
            {
                System.out.println("image '" + s + "' not found");
            }
            else
            {
                byte[] buffy = new byte[ in.available() ];
                in.read( buffy );
                i = get( buffy );
            }
        }
        else
        {
            URL u = new URL( baseURL + s );
            i = applet.getImage( u );
            waitForImage( i );
        }
        return i ;
    }
    */

    /* Attempt to get the image and absorb an exception if one is encountered. <p>
    */
    /*
    public static Image get( String s )
    {
        Image i = null ;
        try
        {
            i = getE( s );
        }
        catch( Exception e ) {}
        return i ;
    }
    */

    /** Pass in a GIF or JPEG image stored as a byte array and get a Java Image object back. <p>
    */
    public static Image get( byte[] imageBytes )
    {
        Image returnVal = null ;
        if ( imageBytes != null )
        {
            returnVal = Toolkit.getDefaultToolkit().createImage( imageBytes );
            waitForImage( returnVal );
        }
        return returnVal ;
    }


}


